apiVersion: unfurl/v1alpha1
kind: Ensemble
spec:
  service_template:
    description: This template shows you how to create a blueprint that deploys a Ansible playbook.
    metadata:
      template_name: Your blueprint
      template_author:
      template_version: 0.1
      primaryDeploymentBlueprint: deployment-task1
      livePreview: #url to a live preview
      image: # url to image
      sourceCodeUrl: # url to the source code repository
      deployments: 0
      webUrl: # url to the source project

    # service_template.py contains the TOSCA type definitions for this blueprint.
    +include:
      file: service_template.py
    # if you want to use the YAML version instead, replace the line above with:
    #  file: service_template.yaml

    topology_template:
      root:
        node: the_root

      node_templates:
        the_root:
          type: ExampleAnsibleManagedResource
          # templates can be incomplete (for example, this is one missing "example_property")
          # the UI will prompt the user to complete them when deploying.

  deployment_blueprints:
    # you can include multiple distinct deployment tasks that will be rendered in the UI
    # by declaring deployment blueprints
    deployment-task1:
      title: Task 1
      # you can set the "cloud" property to restrict the deployment blueprint
      # so that it can only be deployed on environments that have been configured to use that cloud provider.
      # for example, uncomment one of these lines:

      # cloud: unfurl.relationships.ConnectsTo.K8sCluster
      # cloud: unfurl.relationships.ConnectsTo.GoogleCloudProject
      # cloud: unfurl.relationships.ConnectsTo.AWSAccount
      # cloud: unfurl.relationships.ConnectsTo.DigitalOcean
      # cloud: unfurl.relationships.ConnectsTo.ComputeMachines

      description: Task 1 description

      # each deployment_blueprint can replace or add templates here
      # resource_templates:
      #   the_root:
      #     type: ExampleAnsibleManagedResource


    testing:
      description: An example for unit testing (used by tests/test_deploy.py)
      visibility: hidden  # don't show this in the UI
      resource_templates:
        the_root:
          type: ExampleAnsibleManagedResource
          properties:
              example_property: foo
